# debug\_traceBlockByHash

### Parameters

1. `Blockhash` - the hash of the block to be traced.
2. `Tracer` - choose from one of these options:
   * `4byteTracer` - Solidity contract functions are [addressed](https://docs.soliditylang.org/en/develop/abi-spec.html#function-selector) using the first four byte of the Keccak-256 hash of their signature. This `tracer` monitors and analyzes the usage of specific function signatures within smart contracts by capturing their unique first four bytes.
   * `callTracer` - collects data about all call frames executed within a transaction, creating a hierarchical list of call frames structured mirroring the EVM's operations. This is useful for debugging and analytical purposes.
   * `prestateTracer` - captures and analyzes the state of the blockchain before the execution of a specific transaction. It helps in understanding the state changes and effects that a transaction will have on the blockchain's data and accounts before the transaction is actually executed.
   * `noopTracer` - returns empty results. This is used for testing purpose.
   * `opcountTracer` - count and track the number of operations (or opcodes) executed during a specific transaction.
   * `unigramTracer` - counts the frequency of occurrence of each opcode.
   * `bigramTracer` - a bigram refers to a sequence of two bytes or characters. This tracer is designed to observe and provide insights into the patterns and occurrences of these two-byte sequences as they appear within the data of executed transactions.
   * `trigramTracer` - a trigram refers to a sequence of three bytes or characters. This tracer is designed to observe and provide insights into the patterns and occurrences of these three-byte sequences as they appear within the data of executed transactions.
   * `evmdisTracer` - generates the bytecode disassembly of executed transactions, providing developers with insights into how smart contracts operate at a low-level bytecode level for debugging, security audits, and performance optimization purposes.

#### Sample Request

{% code overflow="wrap" %}

```
curl https://lb.nodies.app/v1/<INSERT URL> \
   -H "x-api-key: <API-KEY>" \
   -X POST \
   -H "Content-Type: application/json" \
   -d '{ 
  "method": "debug_traceBlockByHash",
  "params": [
    "0x553d91fdc67ece85d294ec115013c304a640eccfec8d4e44efbbd181e683777a",
    {
      "tracer": "4byteTracer"
    }
  ],
  "id": 1,
  "jsonrpc": "2.0"
}'
```

{% endcode %}

#### Sample Response

```
{
   "jsonrpc": "2.0",
   "id": 1,
   "result": [
      {
         "result": {
            "0x128acb08-192": 1,
            "0x3850c7bd-0": 1,
            "0x70a08231-32": 5,
            "0xbbc065c9-64": 2
         }
      },
      {
         "result": {
            "0x0000001b-45": 1,
            "0x128acb08-224": 1
         }
      },
      {
         "result": {
            "0x128acb08-192": 1,
            "0x3850c7bd-0": 1,
            "0x70a08231-32": 5,
            "0xbbc065c9-64": 2
         }
      },
      {
         "result": {
            "0x43a54c65-160": 1,
            "0xe76c01e4-0": 1
         }
      },
      {
         "result": {
            "0x128acb08-192": 1,
            "0x70a08231-32": 5,
            "0xbbc065c9-64": 2,
            "0xe76c01e4-0": 1
         }
      },
      {
         "result": {
            "0x128acb08-384": 1,
            "0x1dd486f2-160": 1,
            "0x23b872dd-96": 2,
            "0x2c8958f6-320": 1,
            "0x36e52fee-96": 1,
            "0x430bf08a-0": 1,
            "0x70a08231-32": 4,
            "0x7f376059-32": 1,
            "0xa9059cbb-64": 3,
            "0xbc651188-224": 1,
            "0xc53a182f-128": 1
         }
      },
      {
         "result": {
            "0x00000032-96": 1,
            "0x128acb08-224": 1,
            "0x287fc58c-142": 1,
            "0x70a08231-32": 5,
            "0xa9059cbb-64": 3,
            "0xfa461e33-128": 1
         }
      },
      {
         "result": {
            "0x00000032-96": 1,
            "0x0becf642-142": 1,
            "0x128acb08-224": 1,
            "0x70a08231-32": 5,
            "0xa9059cbb-64": 3,
            "0xfa461e33-128": 1
         }
      },
      {
         "result": {
            "0x09c5eabe-11424": 2,
            "0x585a9fd4-576": 2,
            "0x73e3d66a-10432": 1
         }
      },
      {
         "result": {
            "0x04e45aaf-224": 1,
            "0x095ea7b3-64": 2,
            "0x128acb08-384": 1,
            "0x1a686502-0": 2,
            "0x23b872dd-96": 2,
            "0x3850c7bd-0": 3,
            "0x5134dc93-224": 1,
            "0x55260f6b-256": 1,
            "0x70a08231-32": 13,
            "0xa9059cbb-64": 1,
            "0xc4ca8e9f-192": 2,
            "0xfa461e33-320": 1
         }
      },
      {
         "result": {
            "0x128acb08-224": 1,
            "0x12aa3caf-548": 1,
            "0x1dd486f2-160": 1,
            "0x2c8958f6-160": 1,
            "0x36e52fee-96": 1,
            "0x430bf08a-0": 1,
            "0x4b64e492-219": 1,
            "0x70a08231-32": 3,
            "0xa9059cbb-64": 4,
            "0xc53a182f-128": 1,
            "0xd0e30db0-0": 1,
            "0xee63c1e5-93": 1
         }
      },
      {
         "result": {
            "0x00000001-55": 1,
            "0x70a08231-32": 1
         }
      },
      {
         "result": {
            "0xa9059cbb-64": 2
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0x095ea7b3-64": 2
         }
      },
      {
         "result": {
            "0x095ea7b3-64": 2
         }
      },
      {
         "result": {
            "0xa9059cbb-64": 1
         }
      },
      {
         "result": {
            "0xa9059cbb-64": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0xc9807539-1216": 1
         }
      },
      {
         "result": {
            "0x110bcd45-160": 2
         }
      },
      {
         "result": {
            "0x110bcd45-160": 2
         }
      },
      {
         "result": {
            "0xa9059cbb-64": 1
         }
      },
      {
         "result": {
            "0xa9059cbb-64": 1
         }
      },
      {
         "result": {
            "0x9d5f4903-192": 1,
            "0xc5e20e84-128": 2
         }
      },
      {
         "result": {
            "0x40c10f19-64": 1,
            "0x7a9a1628-864": 2
         }
      },
      {
         "result": {
            "0x2812fe21-128": 1,
            "0xe74094ed-64": 1
         }
      },
      {
         "result": {
            "0x2812fe21-128": 1,
            "0xe74094ed-64": 1
         }
      },
      {
         "result": {}
      },
      {
         "result": {
            "0x128acb08-192": 1,
            "0x1dd486f2-160": 1,
            "0x2c8958f6-128": 1,
            "0x36e52fee-96": 1,
            "0x430bf08a-0": 1,
            "0x43a54c65-160": 1,
            "0x70a08231-32": 4,
            "0x7f376059-32": 1,
            "0xa9059cbb-64": 5,
            "0xc53a182f-128": 1,
            "0xe76c01e4-0": 1
         }
      },
      {
         "result": {}
      },
      {
         "result": {
            "0x022c0d9f-160": 3,
            "0x0902f1ac-0": 3,
            "0x0dfe1681-0": 1,
            "0x57da8d0d-61": 1,
            "0x70a08231-32": 13,
            "0xa9059cbb-64": 5,
            "0xd21220a7-0": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0xc9807539-1216": 1
         }
      },
      {
         "result": {
            "0xc9807539-1216": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0xc9807539-1216": 1
         }
      },
      {
         "result": {
            "0xc9807539-1248": 1
         }
      },
      {
         "result": {
            "0x001d3567-800": 1,
            "0x068bcd8d-32": 2,
            "0x252f7b01-864": 2,
            "0x2f925555-576": 1,
            "0x902b8ab7-288": 1,
            "0x987fa2d5-864": 1,
            "0xa18fa804-160": 1,
            "0xa9059cbb-64": 2,
            "0xb6addec7-128": 1,
            "0xb71e0f71-768": 1,
            "0xc2fa4813-864": 1
         }
      },
      {
         "result": {
            "0xa9059cbb-64": 2
         }
      },
      {
         "result": {
            "0xca4ac0f3-384": 1
         }
      },
      {
         "result": {
            "0xca4ac0f3-384": 1
         }
      },
      {
         "result": {
            "0x0c53c51c-512": 2,
            "0x23b872dd-96": 1,
            "0x6352211e-32": 1,
            "0xeaeb713e-308": 2
         }
      },
      {
         "result": {
            "0xa9059cbb-64": 1
         }
      },
      {
         "result": {
            "0xa9059cbb-64": 1
         }
      },
      {
         "result": {
            "0x1d732756-800": 2,
            "0x1fad948c-2208": 1,
            "0x3a871cdd-1120": 6,
            "0x51945447-256": 4,
            "0xa9059cbb-64": 2,
            "0xf465c77e-1120": 2
         }
      },
      {
         "result": {
            "0x1d732756-800": 7,
            "0x1fad948c-7488": 1,
            "0x3a871cdd-1120": 21,
            "0x51945447-256": 14,
            "0xa9059cbb-64": 7,
            "0xf465c77e-1120": 7
         }
      },
      {
         "result": {
            "0xd204c45e-192": 2
         }
      },
      {
         "result": {
            "0x128acb08-384": 1,
            "0x1dd486f2-160": 1,
            "0x23b872dd-96": 2,
            "0x2c8958f6-320": 1,
            "0x36e52fee-96": 1,
            "0x430bf08a-0": 1,
            "0x70a08231-32": 4,
            "0x7f376059-32": 1,
            "0xa9059cbb-64": 3,
            "0xc53a182f-128": 1,
            "0xdb3e2198-256": 1
         }
      },
      {
         "result": {
            "0x022c0d9f-160": 1,
            "0x0902f1ac-0": 1,
            "0x23b872dd-96": 2,
            "0x5c11d795-256": 1,
            "0x70a08231-32": 7,
            "0xa9059cbb-64": 1
         }
      },
      {
         "result": {
            "0x095ea7b3-64": 1
         }
      },
      {
         "result": {
            "0x0962ef79-32": 2,
            "0xa9059cbb-64": 2
         }
      },
      {
         "result": {}
      },
      {
         "result": {
            "0xa9059cbb-64": 2
         }
      },
      {
         "result": {
            "0x43c61747-288": 1
         }
      },
      {
         "result": {
            "0x128acb08-384": 1,
            "0x23b872dd-96": 2,
            "0x414bf389-256": 1,
            "0x70a08231-32": 4,
            "0xa9059cbb-64": 2,
            "0xfa461e33-320": 1
         }
      },
      {
         "result": {
            "0x6214bc0a-32": 1
         }
      },
      {
         "result": {
            "0x1a3cd59a-32": 2,
            "0x8fd4cf84-224": 2,
            "0xe0b4e8a6-320": 2,
            "0xec91fa5b-96": 2,
            "0xf23a6e61-192": 2,
            "0xf242432a-192": 2,
            "0xf4c30997-96": 2
         }
      },
      {
         "result": {
            "0x1c560305-64": 100,
            "0x6662c907-160": 200,
            "0x6d5433e6-64": 100,
            "0x7ae2b5c7-64": 100,
            "0xf27dc7b6-64": 1
         }
      },
      {
         "result": {
            "0x33d98fd9-896": 2
         }
      },
      {
         "result": {
            "0x41706c4e-640": 2,
            "0x572b6c05-32": 2,
            "0x70a08231-32": 2,
            "0xa9059cbb-84": 2,
            "0xcc2a15a7-160": 2
         }
      }
   ]
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.nodies.app/supported-api-methods/polygon-mainnet-pos/debug_traceblockbyhash.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
